"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var registry_1 = require('./registry');
var express = require('express');
var chai_1 = require('chai');
var request = require('supertest');
var js_restful_1 = require('js-restful');
var util = require('./test-util.spec');
var anyBook = { name: 'simsons' };
var TestService = (function () {
    function TestService() {
    }
    TestService.prototype.doPut = function () {
    };
    TestService.prototype.postName = function (id) {
        return true;
    };
    __decorate([
        js_restful_1.DELETE(), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], TestService.prototype, "doPut", null);
    __decorate([
        js_restful_1.DELETE(),
        js_restful_1.Path('/:id'),
        __param(0, js_restful_1.PathParam('id')), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [Number]), 
        __metadata('design:returntype', void 0)
    ], TestService.prototype, "postName", null);
    TestService = __decorate([
        js_restful_1.Path('/books'), 
        __metadata('design:paramtypes', [])
    ], TestService);
    return TestService;
}());
describe('service-registry: HTTP DELETE methods', function () {
    var app;
    var testService;
    beforeEach(function () {
        app = express();
        testService = new TestService();
        new registry_1.JsRestfulRegistry(app).registerService(testService);
    });
    it('should test a DELETE method without a path', function (done) {
        request.agent(app).delete('/books').end(function (err, res) {
            chai_1.expect(res.status).to.equal(200);
            chai_1.expect(res.text).to.eql('');
            done();
        });
    });
    it('should test a DELETE method with a param', function (done) {
        request.agent(app).delete('/books/1').end(function (err, res) {
            util.checkDefaultsText(err, res, done);
            chai_1.expect(res.text).to.eql('true');
            done();
        });
    });
});
//# sourceMappingURL=registry-delete.spec.js.map