"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var registry_1 = require('./registry');
var express = require('express');
var chai_1 = require('chai');
var request = require('supertest');
var js_restful_1 = require('js-restful');
var util = require('./test-util.spec');
var anyBook = { a: 'b' };
var TestService = (function () {
    function TestService() {
    }
    TestService.prototype.doPost = function () {
    };
    TestService.prototype.postWithAdditionalPath = function () {
        return [anyBook];
    };
    TestService.prototype.postName = function (name) {
        return { id: 1, name: name };
    };
    __decorate([
        js_restful_1.POST(), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], TestService.prototype, "doPost", null);
    __decorate([
        js_restful_1.POST(),
        js_restful_1.Path('/archived'), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], TestService.prototype, "postWithAdditionalPath", null);
    __decorate([
        js_restful_1.POST(),
        js_restful_1.Path('/:name'),
        __param(0, js_restful_1.PathParam('name')), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [String]), 
        __metadata('design:returntype', void 0)
    ], TestService.prototype, "postName", null);
    TestService = __decorate([
        js_restful_1.Path('/books'), 
        __metadata('design:paramtypes', [])
    ], TestService);
    return TestService;
}());
describe('service-registry: HTTP POST methods', function () {
    var app;
    var testService;
    beforeEach(function () {
        app = express();
        testService = new TestService();
        new registry_1.JsRestfulRegistry(app).registerService(testService);
    });
    it('should test a POST method without a path', function (done) {
        request.agent(app).post('/books').end(function (err, res) {
            chai_1.expect(res.status).to.equal(200);
            chai_1.expect(res.text).to.eql('');
            done();
        });
    });
    it('should test a POST method with a path', function (done) {
        request.agent(app).post('/books/archived').end(function (err, res) {
            util.checkDefaultsJson(err, res, done);
            chai_1.expect(res.body).to.eql([anyBook]);
            done();
        });
    });
    it('should test a POST method with a param', function (done) {
        request.agent(app).post('/books/simsons').end(function (err, res) {
            util.checkDefaultsJson(err, res, done);
            chai_1.expect(res.body).to.eql({ id: 1, name: 'simsons' });
            done();
        });
    });
});
//# sourceMappingURL=registry-post.spec.js.map