"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var registry_1 = require('./registry');
var express = require('express');
var chai_1 = require('chai');
var request = require('supertest');
var js_restful_1 = require('js-restful');
var util = require('./test-util.spec');
var es6_promise_1 = require('es6-promise');
var anyBook = { a: 'b' };
var TestService = (function () {
    function TestService() {
    }
    TestService.prototype.get = function () {
        var p = new es6_promise_1.Promise(function (resolve, reject) {
            resolve([anyBook]);
        });
        return p;
    };
    __decorate([
        js_restful_1.GET(), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], TestService.prototype, "get", null);
    TestService = __decorate([
        js_restful_1.Path('/books'), 
        __metadata('design:paramtypes', [])
    ], TestService);
    return TestService;
}());
var TestServiceB = (function () {
    function TestServiceB() {
    }
    TestServiceB.prototype.get = function () {
        var p = new es6_promise_1.Promise(function (resolve, reject) {
            reject(new Error('test error'));
        });
        return p;
    };
    __decorate([
        js_restful_1.GET(), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], TestServiceB.prototype, "get", null);
    TestServiceB = __decorate([
        js_restful_1.Path('/books'), 
        __metadata('design:paramtypes', [])
    ], TestServiceB);
    return TestServiceB;
}());
describe('service-registry: implementations with promises', function () {
    var app;
    var testService;
    beforeEach(function () {
        app = express();
    });
    it('should test a GET method with a service that return a promise', function (done) {
        new registry_1.JsRestfulRegistry(app).registerService(new TestService());
        request.agent(app).get('/books').end(function (err, res) {
            util.checkDefaultsJson(err, res, done);
            chai_1.expect(res.body).to.eql([anyBook]);
            done();
        });
    });
    it('should send an error if the promise is rejected', function (done) {
        new registry_1.JsRestfulRegistry(app).registerService(new TestServiceB());
        request.agent(app).get('/books').end(function (err, res) {
            chai_1.expect(res.status).to.equal(500);
            chai_1.expect(JSON.stringify(res.error)).to.contains('test error');
            done();
        });
    });
});
//# sourceMappingURL=registry-promis.spec.js.map