import * as express from 'express';
import 'reflect-metadata';
import { MethodDescription } from 'js-restful';
export interface IRenderer {
    render(res: express.Response, value: any): any;
}
export declare class RenderWithRenderer implements IRenderer {
    private viewName;
    constructor(viewName: string);
    render(res: express.Response, value: any): void;
}
export declare class DefaultRenderer implements IRenderer {
    private method;
    constructor(method: MethodDescription);
    render(res: express.Response, value: any): void;
    private isResponseParameterPresent();
    private setToPlainText(res);
}
export declare class RendererFactory {
    static getRenderer(service: any, method: MethodDescription): IRenderer;
}
