"use strict";
var chai_1 = require('chai');
function checkHttpStatus(err, res, done) {
    if (err)
        return done(err);
    chai_1.expect(res.status).to.equal(200);
}
exports.checkHttpStatus = checkHttpStatus;
function checkDefaultsJson(err, res, done) {
    checkHttpStatus(err, res, done);
    chai_1.expect(res.header).to.contain({ 'content-type': 'application/json; charset=utf-8' });
}
exports.checkDefaultsJson = checkDefaultsJson;
function checkDefaultsText(err, res, done) {
    checkHttpStatus(err, res, done);
    chai_1.expect(res.header).to.contain({ 'content-type': 'text/plain; charset=utf-8' });
}
exports.checkDefaultsText = checkDefaultsText;
var Context = (function () {
    function Context() {
    }
    Context.prototype.isUserInRole = function (roleName) {
        return roleName === 'user';
    };
    return Context;
}());
exports.Context = Context;
var Factory = (function () {
    function Factory() {
    }
    Factory.prototype.createSecurityContext = function (req) {
        return new Context();
    };
    return Factory;
}());
exports.Factory = Factory;
//# sourceMappingURL=test-util.spec.js.map